<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/vars.php";
include_once "include/config.php";
include_once "$theme/theme.php";
include_once "include/mime.php";
include_once "include/common.php";
include_once "include/export.php";
include_once "include/orderby.php";
include_once "include/site.php";

$database = site_prolog();

if ($po_user['type'] < $user_type['user']) {
  site_epilog($database);
  header("location: login.php");
  exit();
}

$source_photo_id   = pg_escape_string($_REQUEST['source_photo']);
$source_folder_id  = pg_escape_string($_REQUEST['source_folder']);
$source_album_id   = pg_escape_string($_REQUEST['source_album']);
$export_type       = $_REQUEST['export_type'];

if ($source_photo_id != "") {
  $photo_data_single = pg_fetch_row(pg_query($database, "select identifier, folder, caption, title from photo where identifier='$source_photo_id'"));
  $photo_data_single[2] = makeZanza($photo_data_single[3] ? $photo_data_single[3] : $photo_data_single[2], "No Title");
  $container_name = pg_fetch_row(pg_query($database, "select caption from folder where identifier=$photo_data_single[1]"));
  $container_name[0] = makeZanza($container_name[0], "No Caption");
  $navigator_status_message = "<a href=\"user.php\">Users</a> : <a href=\"user.php?user=$po_user[id]\">My folders and albums</a> : <a href=\"folder.php?folder=$photo_data_single[1]\">$container_name[0]</a> : <a href=\"photo.php?photo=$source_photo_id\">$photo_data_single[2]</a> : Exporting Photos";
} elseif ($source_album_id != "") {
  $container_name = pg_fetch_row(pg_query($database, "select caption from album where identifier='$source_album_id'"));
  $container_name[0] = makeZanza($container_name[0], "No Caption");
  $navigator_status_message = "<a href=\"user.php\">Users</a> : <a href=\"user.php?user=$po_user[id]\">My folders and albums</a> : <a href=\"album.php?album=$source_album_id\">$container_name[0]</a> : Exporting Photos";
} elseif ($source_folder_id != "") {
  $container_name = pg_fetch_row(pg_query($database, "select caption from folder where identifier='$source_folder_id'"));
  $container_name[0] = makeZanza($container_name[0], "No Caption");
  $navigator_status_message = "<a href=\"user.php\">Users</a> : <a href=\"user.php?user=$po_user[id]\">My folders and albums</a> : <a href=\"folder.php?folder=$source_folder_id\">$container_name[0]</a> : Exporting Photos";
}

$photos_in_spooler = pg_query($database, "
  select photo.identifier
    from photo_spooler, photo
   where photo.identifier = photo_spooler.photo
     and photo_spooler.users = $po_user[id]");

site_header($page_width, "Export Photos");
site_navigator(5);
site_navigator_status($navigator_status_message, "");

print "<div align=\"left\">";
print "&nbsp;<br/>\n";
print "Exporting <b>".pg_num_rows($photos_in_spooler)."</b> photos<br/>\n";

$temporary_directory = tempnam($tmp_volume_path, "po.export.");
unlink($temporary_directory);
$tar_file_name = $temporary_directory . ".tar";

$export_id = basename($temporary_directory);
$export_id = substr($export_id, strlen("po.export."));

print "Creating temporary directory <b>$temporary_directory</b> ... ";
$old_mask = umask(0000);
if (!mkdir($temporary_directory)) {
  print "<font color=\"red\">failed</font> [mkdir $temporary_directory]<br/>";
} else {
  print "done.<br/>";
}

switch($export_type) {
 case "photo":
 case "photo_xml_iptc":
 case "photo_iptc":
 default:
   break;
 case "photo_xml":
   print "Creating XML photo description file <b>$temporary_directory/data.xml</b> ... ";
   if (($xml_file_desciptor = fopen ($temporary_directory."/data.xml", "w+")) == FALSE) {
     print "<font color=\"red\">failed</font> [fopen $temporary_directory/data.xml]<br/>";
   } else {
     print "done.<br/>";
   }

   fwrite($xml_file_desciptor, create_xml_header());
   fwrite($xml_file_desciptor, create_xml_bulkupload_header());
   break;
}

/* creates the tar archive */
$operation = "c";

for ($photos = 0; $photos < pg_num_rows($photos_in_spooler); $photos++) {
  $photo_identifier = pg_fetch_row($photos_in_spooler, $photos);

  /* optimize query, by excluding fields that are not used when not exporting shooting data */
  switch($export_type) {
  case "photo_xml_iptc":
  case "photo_iptc":
  case "photo_xml":
    $photo_data = pg_fetch_row(pg_query($database, "
       select folder, author, title, '' as keyword, caption, copyright_statement, date_of_exposure,
              location, storage_location, storage_index,
              access_rights, hide_original,
              camera, lens, filter, film, flash, scanner, focal_length, aperture, shutter,
              exposure_comp, ev_difference, camera_metering, camera_program, flash_mode, flash_comp,
              scan_resolution, scan_bitdepth, scan_multiscan, iso_override, support
         from photo, photo_version, photo_tech, photo_dupe
        where photo.identifier = photo_version.photo
          and photo.identifier = photo_dupe.photo
          and photo.identifier = photo_tech.photo
          and photo.identifier = $photo_identifier[0]
          and photo_dupe.key = 1"));

    /* Get any keywords for the photo... */
    $res = pg_query($database, "select keyword from photo_keywords where photo=$photo_identifier[identifier]");
    $keywords = FALSE;
    for ($i=0; $i < pg_num_rows($res); $i++) {
      $dat = pg_fetch_assoc($res);
      $keywords[$i] = $dat['keyword'];
    }

    break;
  case "photo":
  default:
    $photo_data = pg_fetch_row(pg_query($database, "
       select photo_version.large_image_path, photo_version.original_image_name
         from photo, photo_version
        where photo.identifier = photo_version.photo
          and photo.identifier = $photo_identifier[0]"));
    break;
  }

  $photo_version_data = pg_query($database, "
     select large_image_path, original_image_name, comment, master
       from photo_version
      where photo_version.photo = $photo_identifier[0]");

  print "&nbsp;<br/>\n";
  print "Exporting <a href=\"photo.php?photo=$photo_identifier[0]\">$title</a>.</p>";
  print "<ul>\n";

  for ($versions = 0; $versions < pg_num_rows($photo_version_data); $versions++) {
    $photo_version_single = pg_fetch_row($photo_version_data, $versions);

    $file_name = $image_repository_path."/".$photo_version_single[0];
    $original_name = $temporary_directory."/".$photo_version_single[1];

    $title = $photo_data[2];
    if ($title == "")
      $title = "No Title $photo_identifier[0]";
    /* check for the source file's existence */
    if (!is_file($file_name)) {
      print "<li><font color=\"purple\">Photo <a href=\"photo.php?photo=$photo_identifier[0]\">$title</a> skipped. ";
      print "File <b>".$file_name."</b> does not exist.</font></li>\n";
      print "</ul>\n";
      continue;
    }

    /* copy original image into the temporary directory with it's original name */
    if (!copy($file_name, $original_name)) {
      print "<li><font color=\"red\">Copying <b>$file_name</b></font> failed [cp $file_name $original_name]</li>";
    }
    else {
      print "<li>Copying <b>$file_name</b> into <b>$original_name</b></li>";
    }
  }

  /* export shooting data */
  switch($export_type) {
  case "photo":
  default:
    break;
  case "photo_xml":
    $image_data = array ("file" => array(0 => array("name" => "", "remark" => "", "master" => "")),
                         "folder"                => $photo_data[0],
                         "author"                => $photo_data[1],
                         "title"                 => $photo_data[2],
                         "keywords"              => $keywords,
                         "caption"               => $photo_data[4],
                         "copyright"             => $photo_data[5],
                         "date_of_exposure"      => $photo_data[6],
                         "location"              => $photo_data[7],
                         "storage_location_type" => $photo_data[8],
                         "storage_location_id"   => $photo_data[8],
                         "storage_index"         => $photo_data[9],
                         "access_rights"         => $photo_data[10],
                         "hide_original"         => $photo_data[11],
                         "camera"                => $photo_data[12],
                         "lens"                  => $photo_data[13],
                         "filter"                => $photo_data[14],
                         "film"                  => $photo_data[15],
                         "flash"                 => $photo_data[16],
                         "scanner"               => $photo_data[17],
                         "focal_length"          => $photo_data[18],
                         "aperture"              => $photo_data[19],
                         "shutter"               => $photo_data[20],
                         "exp_comp"              => $photo_data[21],
                         "exp_diff"              => $photo_data[22],
                         "camera_metering"       => $photo_data[23],
                         "camera_program"        => $photo_data[24],
                         "flash_mode"            => $photo_data[25],
                         "flash_comp"            => $photo_data[26],
                         "scan_resolution"       => $photo_data[27],
                         "scan_bitdepth"         => $photo_data[28],
                         "scan_multiscan"        => $photo_data[29],
                         "iso_override"          => $photo_data[30],
                         "support"               => $photo_data[31]);

    for ($versions = 0; $versions < pg_num_rows($photo_version_data); $versions++) {
      $photo_version_single = pg_fetch_row($photo_version_data, $versions);
      $image_data['file'][$versions]['name']   = $photo_version_single[1];
      $image_data['file'][$versions]['remark'] = $photo_version_single[2];
      $image_data['file'][$versions]['master'] = $photo_version_single[3];
    }

    fwrite($xml_file_desciptor, create_xml_folder_header($image_data['folder']));
    fwrite($xml_file_desciptor, create_xml_photo($image_data));
    fwrite($xml_file_desciptor, create_xml_folder_footer());
    print "<li>Appending XML data to <b>$temporary_directory/data.xml</b>.</li>";
    break;
  case "photo_xml_iptc":
  case "photo_iptc":
    print "&nbsp;<br/>\n";
    print "<font color=\"red\">IPTC embedding is not yet implemented.</font></p>";
  }

  for ($versions = 0; $versions < pg_num_rows($photo_version_data); $versions++) {
    $photo_version_single = pg_fetch_row($photo_version_data, $versions);

    $original_name = $temporary_directory."/".$photo_version_single[1];

    /* append image file to the tarball */
    $command = $sys_tar." ".$operation."vf ".$tar_file_name." -C ".$temporary_directory." \"".$photo_version_single[1]."\"";
    /* we use "exec" instead of "system" to avoid unwanted output */
    exec($command, $who_cares, $retval_tar);
    if ($retval_tar) {
      print "<li><font color=\"red\">Export failed - $command returned <b>$retval_tar</b></font></li>\n";
      error_reporting(0);
      unlink($original_name);
      error_reporting(1);
      return false;
    }
    else {
      print "<li>File <b>$original_name</b> added to the <b>$tar_file_name</b> archive.</li>\n";
    }

    /* remove temporary copy of the original image */
    if (!unlink($original_name)) {
      print "<li><font color=\"red\">Removing <b>$original_name</b></font> failed [unlink $original_name]</li>";
    }
    else {
      print "<li>Removing <b>$original_name</b></li>";
    }

    /* from now on, append to the tar archive */
    $operation = "r";
  }

  print "</ul>\n";
  flush();
}

switch($export_type) {
 case photo:
 case "photo_xml_iptc":
 case "photo_iptc":
 default:
   break;
 case "photo_xml":
   print "Closing XML description file<br/>";
   fwrite($xml_file_desciptor, create_xml_bulkupload_footer());
   fclose($xml_file_desciptor);
   $command = $sys_tar." ".$operation."vf ".$tar_file_name." -C ".$temporary_directory." data.xml";
   /* we use "exec" instead of "system" to avoid unwanted output */
   exec($command, $who_cares, $retval_tar);
   if ($retval_tar) {
     print "<font color=\"red\">Export failed - $command returned <b>$retval_tar</b></font><br/>\n";
     error_reporting(0);
     unlink($original_name);
     error_reporting(1);
     return false;
   }
   else {
     print "XML description file <b>$temporary_directory/data.xml</b> added to the <b>$tar_file_name</b> archive.<br/>\n";
   }

   /* after adding the data.xml file to the tarball, remove it */
   if (!unlink($temporary_directory."/data.xml")) {
     print "<font color=\"red\">Removing <b>$temporary_directory/data.xml</b></font> failed [unlink $temporary_directory/data.xml]<br/>";
   }
   else {
     print "Removing <b>$temporary_directory/data.xml</b><br/>";
   }

   print "\n";
   flush();

   break;
}

print "<br/>Removing temporary directory <b>$temporary_directory</b> ... ";
if (!rmdir($temporary_directory)) {
  print "<font color=\"red\">failed</font> [rmdir $temporary_directory]<br/>";
}
else {
  print "done.<br/>";
}
umask($old_mask);
print "Export finished.<p>";

print "&nbsp;<br/>\n";
print "Click <a href=\"export.2.php?export_id=".$export_id."\">here</a> to retrieve your exported photos.\n";
print "&nbsp;<br/>\n";
print "</div>\n";

print "&nbsp;<br/>\n";
site_footer($database);
site_epilog($database);
?>
