<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "config.php";
include_once "common.php";
include_once "vars.php";
include_once "database.php";

function site_prolog() {
  global $po_cookie;
  global $po_user;

  $sybase = FALSE;
  // if magic quotes is enabled
  if ( get_magic_quotes_gpc () ) {
    // workaround because magic_quotes does not change $_SERVER['argv']
    $argv = isset($_SERVER['argv']) ? $_SERVER['argv'] : NULL; 
    
    // fix all affected arrays
    foreach ( array ('_ENV', '_REQUEST', '_GET', '_POST', '_COOKIE', '_SERVER') as $var ) {
      $GLOBALS[$var] = fix_magic_quotes ($GLOBALS[$var], $sybase);
    }
    $_SERVER['argv'] = $argv;
    
    // turn off magic quotes, this is so scripts which
    // are sensitive to the setting will work correctly
    ini_set ('magic_quotes_gpc', 0);
  }
  
  set_magic_quotes_runtime(0);
  
  /* Turn off error display */
  ini_set ('display_errors', 0);
  
  /* Establish DB Connection */
  $dbh = po_dbconnect();
  
  if ($dbh == FALSE) return FALSE;

  /* See if user is logged in; Set up session data.. */
  if (isset($_COOKIE[$po_cookie])) {
    $session_id = pg_escape_string($_COOKIE[$po_cookie]);
    
    $res = pg_query($dbh, "SELECT identifier, type, preferences, username, first_name, last_name, password
                             FROM users
                            WHERE session_id='$session_id'");
    if (($res != FALSE) && pg_num_rows($res)) {
      $row = pg_fetch_assoc($res);
      $po_user['id'] = $row['identifier'];
      $po_user['type'] = $row['type'];
      $po_user['session'] = $session_id;
      $po_user['prefs'] = $row['preferences'];
      $po_user['username'] = $row['username'];
      $po_user['first_name'] = $row['first_name'];
      $po_user['last_name'] = $row['last_name'];
      $po_user['password'] = $row['password'];
    }
  }

  return $dbh;
}

function site_epilog($database) {
  pg_close($database);
}

function site_adv() {
  global $ad_script;

  if ($ad_script) {
    print "<div class=\"banner_adv\">";
    print $ad_script;
    print "</div>";
 }
}

function site_logo($align) {
  global $site_url;
  global $site_title;

  print "<div align=\"$align\"><a class=\"nodecor\" href=\"$site_url\"><img src=\"themes/aqua/logo.gif\" border=\"0\" title=\"Click here to visit the $site_title Web Site\" alt=\"Photo Organizer Logo\"/></a></div>\n";
}

function site_credit($align, $show_version, $framed) {
  global $color;

  if ($framed) {
    print "<table align=\"center\" cellspacing=\"1\" cellpadding=\"3\" bgcolor=\"$color[table_background]\" border=\"0\" width=\"100%\">\n";
    print "<tr><td align=\"left\" bgcolor=\"$color[table_header]\">\n";
  }

  print "<div align=\"$align\">";
  if ($show_version) {
    $php_version = version();
    print "Powered by <a class=\"nodecor\" href=\"http://po.shaftnet.org/\">Photo Organizer</a> v$php_version<br/>\n";   }

  print "Copyright &copy; 2002-2006 <a class=\"nodecor\" href=\"http://www.k-i-s.net\">Balint Kis</a>, &copy; 2005-2007 <a class=\"nodecor\" href=\"http://www.shaftnet.org/users/pizza\">Solomon Peachy</a>, and is available under the terms of the <a class=\"nodecor\" href=\"copyright.php\">GNU GPL</a>.\n";
  print "</div>\n";

  if ($framed) {
    print "</td></tr>\n";
    print "</table>\n";
  }
}

function site_head($page_title) {
  global $theme;
  global $compress_pages;
  global $site_title;

  if ($compress_pages &&
      ini_get('zlib.output_compression') == '' &&
      ini_get('zend_accelerator.compress_all') == '' &&
      ini_get('output_handler') != 'ob_gzhandler') {
    if (ob_get_level()) {
      ob_end_clean();
    }
    ob_start('ob_gzhandler');
  }

  print "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">";
  print "<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\">";
  print "<head>\n";
  print "<title>$site_title : $page_title</title>\n";
  print "<link rel=\"shortcut icon\" href=\"$theme/icon.jpg\" />\n";
  print "<link rel=\"stylesheet\" type=\"text/css\" media=\"screen\" href=\"$theme/screen.css\" />\n";
  print "<link rel=\"stylesheet\" type=\"text/css\" media=\"print\"  href=\"$theme/screen.css\" />\n";

  print "<link rel=\"stylesheet\" type=\"text/css\" media=\"all\" href=\"$theme/jscalendar/theme.css\" title=\"win2k-cold-1\" />";

  print "<script language=\"JavaScript\" type=\"text/javascript\" src=\"javascript/jscalendar/calendar.js\"></script>";
  print "<script language=\"JavaScript\" type=\"text/javascript\" src=\"javascript/jscalendar/lang/calendar-en.js\"></script>";
  print "<script language=\"JavaScript\" type=\"text/javascript\" src=\"javascript/jscalendar/calendar-setup.js\"></script>";

  print "</head>\n";
}

function site_header($page_width, $page_title) {
  global $color;
  global $po_user;
  global $user_type;
  global $install_enabled;

  site_head($page_title);

  print "<body text=\"$color[foreground]\" bgcolor=\"$color[background]\" link=\"$color[link]\" vlink=\"$color[v_link]\" alink=\"$color[a_link]\">\n";


  if (($po_user['type'] == $user_type['administrator']) &&
      ($po_user['username'] == 'admin') &&
      ($po_user['password'] == 'admin')) {
    print "<h2><font color=\"red\">You are using the default admin account and 
have not changed the default password.  This is a major security risk!</font></h2>\n";
  }

  if ($install_enabled) {
    print "<h2><font color=\"red\">You have the installer script enabled.   Please set \$install_enabled=0 in your config_site.php to disable the installer.  Continuing with it enabled is a security risk!</font></h2>\n";
  }

  print "<table align=\"center\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\" width=\"$page_width\">\n";
  print "<tr>\n<td align=\"left\" valign=\"top\">\n";
  site_logo("left");
  site_adv();
}

function site_foot() {
  print "</body></html>\n";
}

function site_footer($database) {
  print "</td>\n</tr>\n";
  print "<tr>\n<td valign=\"bottom\">\n";
  site_credit("center", true, true);
  print "</td>\n</tr>\n";
  print "</table>\n";
  print "&nbsp;<br/>\n";
  site_foot();
}

function site_navigator_status($left_string, $right_string) {
  global $color;

  print "<!-- Navigator Status Begin -->\n";
  print "<table align=\"center\" cellspacing=\"1\" bgcolor=\"$color[table_background]\" border=\"0\" width=\"100%\">\n";
  print "<tr>\n";
  print "<td bgcolor=\"$color[table_header]\">\n";

  print "<table cellpadding=\"1\" width=\"100%\">\n";
  print "<tr>\n";
  print "<td align=\"left\">$left_string</td>\n";
  print "<td align=\"right\">$right_string</td>\n";
  print "</tr>\n";
  print "</table>\n";

  print "</td>\n";
  print "</tr>\n";
  print "</table>\n";
  print "<!-- Navigator Status End -->\n";
}

function site_navigator_stand_alone($database, $sub_menu) {

  site_navigator($sub_menu);
}

function site_navigator($sub_menu) {
  global $theme;
  global $user_type;
  global $po_user;

  $type = $po_user['type'];

  print "<!-- Navigator Begin -->\n";
  print "<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\" width=\"100%\">\n";
  print "<tr>\n";

  print "<td align=\"left\">\n";
  print "<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\">\n";
  print "<tr>\n";

  if ($type >= $user_type['user']) {
    print "<td>";
    if ($sub_menu==5)
    {
    	print "<a class=\"nodecor\" href=\"my.folder.php\"><img src=\"$theme/notebook.myfolders.a.gif\" alt=\"My Folders\" border=\"0\"/></a>";
    } else {
    	print "<a class=\"nodecor\" href=\"my.folder.php\"><img src=\"$theme/notebook.myfolders.gif\" alt=\"My Folders\" border=\"0\"/></a>";
    }
    print "</td>\n";
  } else if ($type == $user_type['client']) {
    print "<td><a class=\"nodecor\" href=\"my.folder.php\">";
    if ($sub_menu==5)
      print "<img src=\"$theme/notebook.myalbums.a.gif\" alt=\"My Albums\" border=\"0\"/>";
    else
      print "<img src=\"$theme/notebook.myalbums.gif\" alt=\"My Folders\" border=\"0\"/>";
    print "</a></td>\n";
  }

  if ($type >= $user_type['client']) {
    print "<td><a class=\"nodecor\" href=\"my.datebook.php\">";
    if ($sub_menu==8)
      print "<img src=\"$theme/notebook.mydatebook.a.gif\" alt=\"My DateBook\" border=\"0\"/>";
    else
      print "<img src=\"$theme/notebook.mydatebook.gif\" alt=\"My DateBook\" border=\"0\"/>";
    print "</a></td>\n";
  }

  if ($type >= $user_type['user']) {
    print "<td><a class=\"nodecor\" href=\"my.profile.php\">";
    if ($sub_menu==6)
      print "<img src=\"$theme/notebook.myprofile.a.gif\" alt=\"My Profile\" border=\"0\"/>";
    else
      print "<img src=\"$theme/notebook.myprofile.gif\" alt=\"My Profile\" border=\"0\"/>";
    print "</a></td>\n";
  }

  if ($type >= $user_type['client']) {
    print "<td><a class=\"nodecor\" href=\"my.settings.php\">";
    if ($sub_menu==7)
      print "<img src=\"$theme/notebook.mysettings.a.gif\" alt=\"My Settings\" border=\"0\"/>";
    else
      print "<img src=\"$theme/notebook.mysettings.gif\" alt=\"My Settings\" border=\"0\"/>";
    print "</a></td>\n";
  }

  if ($type >= $user_type['user']) {
    print "<td><a class=\"nodecor\" href=\"my.tools.php\">";
    if ($sub_menu==10)
      print "<img src=\"$theme/notebook.mytools.a.gif\" alt=\"My Tools\" border=\"0\"/>";
    else
      print "<img src=\"$theme/notebook.mytools.gif\" alt=\"My Tools\" border=\"0\"/>";
    print "</a></td>\n";
  }

  if ($user_type['disabled'] < $type && $type < $user_type['administrator']) {
    print "<td><a class=\"nodecor\" href=\"basket.php\">";
    if ($sub_menu==11)
      print "<img src=\"$theme/notebook.mybasket.a.gif\" alt=\"My Basket\" border=\"0\"/>";
    else
      print "<img src=\"$theme/notebook.mybasket.gif\" alt=\"My Basket\" border=\"0\"/>";
    print "</a></td>\n";
  }

  if ($type == $user_type['administrator']) {
    print "<td><a class=\"nodecor\" href=\"admin.php\">";
    if ($sub_menu==9)
      print "<img src=\"$theme/notebook.admin.a.gif\" alt=\"Admin\" border=\"0\"/>";
    else
      print "<img src=\"$theme/notebook.admin.gif\" alt=\"Admin\" border=\"0\"/>";
    print "</a></td>\n";
  }

  print "<td></td>\n";

  print "</tr>\n";
  print "</table>\n";
  print "</td>\n";

  print "<td align=\"right\">\n";

  print "<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\">\n";
  print "<tr>\n";
  print "<td><a class=\"nodecor\" href=\"user.php\">";
  if ($sub_menu==1)
    print "<img src=\"$theme/notebook.users.a.gif\" alt=\"Users\" border=\"0\"/>";
  else
    print "<img src=\"$theme/notebook.users.gif\" alt=\"Users\" border=\"0\"/>";
  print "</a></td>\n";

  print "<td><a class=\"nodecor\" href=\"search.php\">";
  if ($sub_menu==2)
    print "<img src=\"$theme/notebook.search.a.gif\" alt=\"Search\" border=\"0\"/>";
  else
    print "<img src=\"$theme/notebook.search.gif\" alt=\"Search\" border=\"0\"/>";
  print "</a></td>\n";

  print "<td><a class=\"nodecor\" href=\"login.php\">";
  if ($type == "" || $type == $user_type['disabled']) {
    if ($sub_menu==3)
      print "<img src=\"$theme/notebook.login.a.gif\" alt=\"Login\" border=\"0\"/>";
    else
      print "<img src=\"$theme/notebook.login.gif\" alt=\"Login\" border=\"0\"/>";
  }
  else {
    if ($sub_menu==3)
      print "<img src=\"$theme/notebook.logout.a.gif\" alt=\"Logout\" border=\"0\"/>";
    else
      print "<img src=\"$theme/notebook.logout.gif\" alt=\"Logout\" border=\"0\"/>";
  }
  print "</a></td>\n";

  print "<td><a class=\"nodecor\" href=\"help.php\">";
  if ($sub_menu==4)
    print "<img src=\"$theme/notebook.help.a.gif\" alt=\"Help\" border=\"0\"/>";
  else
    print "<img src=\"$theme/notebook.help.gif\" alt=\"Help\" border=\"0\"/>";
  print "</a></td>\n";
  print "</tr>\n";
  print "</table>\n";
  print "</td>\n";
  print "</tr>\n";
  print "</table>\n";
  print "<!-- Navigator End -->\n";
}

function site_search_entry($align, $size) {
  global $theme;

  print "<form action=\"search.text.general.php\" method=\"post\">";
  print "<table align=\"center\" border=\"0\">";
  print "<tr><td  align=\"center\">";
  print "<input type=\"text\" name=\"search_string\" value=\"$search_string\" size=\"$size\"/>";
  print "</td><td align=\"center\">";
  print "<input type=\"image\" src=\"$theme/button.search.gif\" border=\"0\" value=\"Search\"/>\n";
  print "</td></tr>";
  print "</table>";
  print "</form>";
}

function site_display_photo($database, $identifier, $framed) {
  global $default_popup_enable;
  global $default_popup_delay;
  global $user_type;
  global $access;
  global $po_user;

  if ($po_user['type'] == $user_type['disabled']) {
    $my_data[0] = $default_popup_enable;
    $my_data[1] = $default_popup_delay;
  } else {
    $my_data = pg_fetch_row(pg_query($database, "select popup_enable, popup_delay from users, preferences where users.identifier=$po_user[id] and users.preferences=preferences.identifier"));
  }

  $photo_owner_data = pg_fetch_row(pg_query($database, "select users from photo where photo.identifier=$identifier"));

  if (($po_user['id'] == $photo_owner_data[0]) || 
      ($po_user['type'] == $user_type['administrator'])) {
    $sql_query_photo_access_rights_string = "";
  } else {
    $client = pg_fetch_row(pg_query($database, "select identifier from client where users=$photo_owner_data[0] and client=$po_user[id] and status=2"));
    if ($client == "") {
      $sql_query_photo_access_rights_string = "and photo.access_rights = $access[public]";
    } else {
      $sql_query_photo_access_rights_string = "and photo.access_rights < $access[private]";
    }
  }

  $photo_data = pg_query($database,
    "select photo.identifier, photo_version.small_image_path, photo.caption, photo.date_of_exposure, photo_dupe.date_of_creation,
            (select value from access_type where access_type.identifier=photo.access_rights) as access_rights,
            11 - (select avg(rating.value) from rating where rating.photo=photo.identifier) as rating,
            views,
            (select is_photo_for_sale(photo.identifier)) as for_sale,
            photo.title, photo.author, '' as keyword
       from photo, photo_dupe, photo_version
      where photo.identifier = '$identifier'
        and photo.identifier = photo_version.photo
        and photo.identifier = photo_dupe.photo
        and photo_dupe.key = 1
        and photo_version.master = 't'
            $sql_query_photo_access_rights_string");

  if (pg_num_rows($photo_data) < 1)
    return;

  display_photo_slides("folder", 0, 1, "", $photo_data, 1, 1, $my_data[0], $my_data[1], false, $framed, "");
}

function site_display_random_photos($database, $type, $identifier, $rows, $columns, $framed) {
  global $theme;
  global $po_user;
  global $default_popup_enable;
  global $default_popup_delay;
  global $user_type;
  global $access;

  $num_of_photos = $rows * $columns;

  if ($po_user['type'] == $user_type['disabled']) {
    $my_data[0] = $default_popup_enable;
    $my_data[1] = $default_popup_delay;
  } else {
    $my_data = pg_fetch_row(pg_query($database, "select popup_enable, popup_delay from users, preferences where users.identifier=$po_user[id] and users.preferences=preferences.identifier"));
  }

  switch ($type) {
  case "user":
    $sql_photo_selector = "photo.users = ".$identifier;
    $sql_extra_tables = "";
    $display_type = "folder";
    $owner_data[0] = $identifier;
    break;
  default:
  case "folder":
    $sql_photo_selector = "photo.folder = ".$identifier;
    $sql_extra_tables = "";
    $display_type = "folder";
    $owner_data = pg_fetch_row(pg_query($database, "select users from folder where folder.identifier=$identifier"));
    break;
  case "album":
    $sql_photo_selector = "photo.identifier = album_content.photo and album_content.album=".$identifier;
    $sql_extra_tables = ", album_content";
    $display_type = "album";
    $owner_data = pg_fetch_row(pg_query($database, "select users from album where album.identifier=$identifier"));
    break;
  }

  if (($po_user['id'] == $photo_owner_data[0]) || 
      ($po_user['type'] == $user_type['administrator'])) {
    $sql_query_photo_access_rights_string = "";
  } else {
    if ($owner_data[0] != "" && $po_user['type'] > $user_type['disabled'])
      $client = pg_fetch_row(pg_query($database, "select identifier from client where users='$owner_data[0]' and client='$po_user[id]' and status=2"));

    if ($client == "") {
      $sql_query_photo_access_rights_string = "and photo.access_rights = $access[public]";
    } else {
      $sql_query_photo_access_rights_string = "and photo.access_rights < $access[private]";
    }
  }

  $photo_data = pg_query($database,
    "select photo.identifier, photo_version.small_image_path, photo.caption, photo.date_of_exposure, photo_dupe.date_of_creation,
            (select value from access_type where access_type.identifier=photo.access_rights) as access_rights,
            11 - (select avg(rating.value) from rating where rating.photo=photo.identifier) as rating,
            views,
            (select is_photo_for_sale(photo.identifier)) as for_sale,
            photo.title, photo.author, '' as keyword
       from photo, photo_dupe, photo_version $sql_extra_tables
      where $sql_photo_selector
        and photo.identifier = photo_version.photo
        and photo.identifier = photo_dupe.photo
        and photo_dupe.key = 1
        and photo_version.master = 't'
        $sql_query_photo_access_rights_string
      order by random()
      limit $num_of_photos");

  $num_of_photos = pg_num_rows($photo_data);
  display_photo_slides($display_type, 0, 1, $identifier, $photo_data, $num_of_photos, $rows, $my_data[0], $my_data[1], false, $framed, "");
}

function site_display_user_name($database, $identifier, $link) {
  $user_name = pg_fetch_row(pg_query($database, "select first_name, last_name from users where identifier = $identifier"));

  if ($link)
    print "<a href=\"user.php?user=$identifier\">$user_name[0] $user_name[1]</a>";
  else
    print "$user_name[0] $user_name[1]";
}

function display_box_with_header($title, $message, $width, $align) {
  global $theme;

  print "<table align=\"center\" cellpadding=\"0\" cellspacing=\"0\" width=\"$width\" border=\"0\">\n";
  print "<tr>\n";
  print "<td align=\"right\"  valign=\"bottom\"><img src=\"$theme/box.top.header.left.gif\"  width=\"8\" height=\"25\" /></td>\n";
  print "<td align=\"center\" valign=\"middle\" background=\"$theme/box.top.header.gif\" width=\"$width\" height=\"25\">$title</td>\n";
  print "<td align=\"left\"   valign=\"bottom\"><img src=\"$theme/box.top.header.right.gif\" width=\"8\" height=\"25\" /></td>\n";
  print "</tr>\n";
  print "<tr>\n";
  print "<td align=\"right\"  valign=\"middle\" width=\"8\" background=\"$theme/box.left.gif\"></td>\n";
  print "<td align=\"$align\" valign=\"middle\" >\n$message\n</td>\n";
  print "<td align=\"left\"   valign=\"middle\" width=\"8\" background=\"$theme/box.right.gif\"></td>\n";
  print "</tr>\n";
  print "<tr>\n";
  print "<td align=\"right\"  valign=\"top\"><img src=\"$theme/box.bottom.left.gif\"  width=\"8\" height=\"8\" /></td>\n";
  print "<td align=\"center\" valign=\"top\" background=\"$theme/box.bottom.gif\" width=\"$width\" height=\"8\"></td>\n";
  print "<td align=\"left\"   valign=\"top\"><img src=\"$theme/box.bottom.right.gif\" width=\"8\" height=\"8\" /></td>\n";
  print "</tr>\n";
  print "</table>\n";
}

?>
