<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/vars.php";
include_once "include/config.php";
include_once "include/common.php";
include_once "include/site.php";
include_once "include/mail.php";
include_once "include/site.php";
include_once "$theme/theme.php";

$username   = pg_escape_string($_REQUEST['username']);
$password   = pg_escape_string($_REQUEST['password']);
$auto_login = $_REQUEST['auto_login'];
$operation  = isset($_REQUEST['operation'])? $_REQUEST['operation'] : "login";

$database = site_prolog();
$error_code = 0;

if ($operation == "send_info") {
  $email  = $_REQUEST['email'];
  if (send_login_information($database, $email))
    $error_code = 2; /* success */
  else
    $error_code = 3; /* failure */
} elseif ($operation == "logout") {
  setcookie($po_cookie, "", 0, "", "", 0);
  $operation = "";

  /* Clear the session ID */
  if ($po_user['id'] != FALSE) {
    pg_query($database, "update users set session_id = null where identifier='$po_user[id]'");
  }

  $po_user['id'] = FALSE;
  $po_user['type'] = $user_type['disabled'];
  $po_user['session'] = FALSE;
} elseif ($operation == "login") {
  if ($po_user['type'] == $user_type['disabled']) {
    /* log in, first check if a username was entered */
    if ($username) {
      $res = pg_query($database, "select identifier, type, shared, session_id from users where username='$username' and password='$password'");
      if ($res != FALSE && pg_num_rows($res)) {
	$user_data = pg_fetch_row($res);
	/* Allow simultaneous logins by using the same sessionid... */
        if (($user_data[2] == "t") && ($user_data[3] != null))
          $po_user['session'] = $user_data[3];
        else
          $po_user['session'] = md5(mt_rand() . $user_data[0]);

	$po_user['id'] = $user_data[0];
	$po_user['type'] = $user_data[1];

        pg_query($database, "update users set session_id='$po_user[session]' where identifier='$user_data[0]'");
        if ($auto_login == "on")
          setcookie($po_cookie, $po_user['session'], time()+157680000, "", "", 0); /* valid for 5 years */
        else
          setcookie($po_cookie, $po_user['session'], 0, "", "", 0); /* valid until the end of session */
      } else {
        $error_code = 1;
        $operation = "logout";
      }
    }
  }
}

/* Ensure we have a valid session! */
$res = pg_query($database, "SELECT identifier, type
                                       FROM users
                                      WHERE session_id='$po_user[session]'");
if (($res != FALSE) && pg_num_rows($res)) {
  $row = pg_fetch_assoc($res);
  $po_user['id'] = $row['identifier'];
  $po_user['type'] = $row['type'];
 } else {
  $po_user['id'] = FALSE;
  $po_user['type'] = $user_type['disabled'];
  $po_user['session'] = FALSE;
  /* Clear the cookie */
  setcookie($po_cookie, "", 0, "", "", 0);
 }

site_header($page_width, "Login");
site_navigator(3);

if ($operation == "get_email") {
  site_navigator_status("<a href=\"login.php\">Login</a> : Preparing your login information request.", "");
  print "&nbsp;<br/>\n";
  print "<center>\n";
  print "Please enter below the email address you have used at registration.<br/>";
  print "The system will look up in the database for that email address,<br/>";
  print "and will send you a message containing your login information.<br/>\n";
  print "&nbsp;<br/>\n";
  print "<form action=\"login.php\" method=\"post\">\n";
  print "<input type=\"hidden\" name=\"operation\" value=\"send_info\"/>\n";
  print "<input type=\"text\" name=\"email\" size=\"40\" tabindex=\"1\"/><br/>\n";
  print "&nbsp;<br/>\n";
  print "<input type=\"image\" src=\"$theme/button.submit.gif\" value=\"Submit Request\"/>";
  print "</form>\n";
  print "</center><p>\n";
 } elseif (($operation == "login") && 
	   ($po_user['type'] > $user_type['disabled'])) {
  $name = pg_fetch_row(pg_query($database, "select first_name, last_name, username, user_type.identifier from users, user_type where users.identifier='$po_user[id]' and users.type=user_type.identifier"));

  switch ($name[3]) {
  case $user_type['disabled']:
    $status_string = "Your account is disabled";
    break;
  case $user_type['client']:
    $status_string = "Your account is a client account.";
    break;
  case $user_type['user']:
    $status_string = "Your account is a user account.";
    break;
  case $user_type['administrator']:
    $status_string = "Your account is an administrator account.";
    break;
  }

  if ($name[0] != "" || $name[1] != "")
    site_navigator_status("You are logged in as <b>$name[0] $name[1]</b>, username: <b>$name[2]</b>", $status_string);
  else
    site_navigator_status("You are logged in as <b>$name[2]</b>", "");
  print "&nbsp;<br/>\n";
  print "<center>\n";
  print "<p align=\"center\">If you wish to log out press the button below.<br/>
         This will remove all cookies set by Photo Organizer,<br/>
         and next time you will need to enter<br/>
         your username and password to log in.</p>\n";
  print "<form action=\"login.php\" method=\"post\">\n";
  print "<input type=\"hidden\" name=\"operation\" value=\"logout\"/>\n";
  print "<input type=\"image\" src=\"$theme/button.logout.gif\" value=\"Log out\"/>";
  print "</form>\n";
  print "</center><p>\n";
} else {
  switch ($error_code) {
  case 0:
    site_navigator_status("Login to gain full access.", "");
    break;
  case 1:
    site_navigator_status("<font color=\"red\">Invalid login, try again.</font>", "");
    break;
  case 2:
    site_navigator_status("Your login information has been sent to: <b>$email</b>.", "");
    break;
  case 3:
    site_navigator_status("<font color=\"red\">No user found with email address: <b>$email</b></font>", "");
    break;
  }

  print "<br/>&nbsp;<br/>\n";

  print "<table align=\"center\" width=\"100%\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\"><tr>\n";
  print "<td align=\"center\" valign=\"top\" >\n";

  print "<form action=\"login.php\" method=\"post\">\n";
  print "<input type=\"hidden\" name=\"operation\" value=\"login\"/>\n";
  print "<table align=\"center\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\">\n";
  print "<tr><td align=\"center\" >Username&nbsp;</td><td><input type=\"text\" name=\"username\" value=\"$username\" tabindex=\"1\"/></td></tr>\n";
  print "<tr><td align=\"center\" >Password&nbsp;</td><td><input type=\"password\" name=\"password\" tabindex=\"2\"/></td></tr>\n";
  print "<tr><td align=\"center\"  colspan=\"2\"><input type=\"checkbox\" name=\"auto_login\" checked/> Log me in automatically in the future</td></tr>\n";
  print "<tr><td align=\"center\" colspan=\"2\"><br/>";
  print "<input type=\"image\" src=\"$theme/button.login.gif\" value=\"Log in\" tabindex=\"3\"/>";
  print "<a class=\"nodecor\" href=\"login.php\"><img src=\"$theme/button.clear.gif\" border=\"0\" alt=\"Clear\"/>";
  print "</a></td></tr>\n";
  print "</table>\n";
  print "</form>\n";

  $system_preferences = pg_fetch_row(pg_query($database, "select new_user_type from system_preferences"));
  if ($system_preferences[0] != $user_type['disabled']) {
    print "&nbsp;<br/>\n";
    print "If you have no username register here:<br/>";
    print "&nbsp;<br/>\n";
    print "<a class=\"nodecor\" href=\"register.php\"><img src=\"$theme/button.register.gif\" border=\"0\" alt=\"Register\"/></a>";
  }

  print "</td></tr><tr><td align=\"center\" valign=\"bottom\" >";
  print "&nbsp;<br/>\n";
  print "If you forgot your username or password click <a href=\"login.php?operation=get_email\">here</a>.<p>";
  print "&nbsp;<br/>\n";
  print "</td>\n";
  print "</tr></table>\n";
}

site_footer($database);
site_epilog($database);
?>
