<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/vars.php";
include_once "include/config.php";
include_once "include/import.php";
include_once "include/site.php";
include_once "$theme/theme.php";
include_once "include/common.php";

$search_request     = isset($_REQUEST['search_x']);
if ($search_request) {
  $keyword_list = "";
  foreach ($_REQUEST['keywords'] as $keyword) {
    $keyword_list .= "$keyword%20";
 }
  if ($keyword_list != "") {
    header("location: search.text.advanced.php?keyword=$keyword_list");
    exit();
  }
 }

$database = site_prolog();

if ($po_user['id'] == FALSE) {
  site_epilog($database);
  header("location: login.php");
  exit();
}

$photo_id           = pg_escape_string($_REQUEST['photo_id']);
$version            = pg_escape_string($_REQUEST['version']);
$destination_basket = pg_escape_string($_REQUEST['basket']);
$destination_folder = pg_escape_string($_REQUEST['destination_folder']);
$destination_album  = pg_escape_string($_REQUEST['destination_album']);
$goto_folder        = pg_escape_string($_REQUEST['goto_folder']);

$set_as_watermark   = $_REQUEST['set_as_watermark'];
$detail_info        = $_REQUEST['detail_info'];
$transform          = $_REQUEST['transform'];
$export_type        = $_REQUEST['export_type'];
$print_type         = $_REQUEST['print_type'];

if ($goto_folder != "") {
  header("location: folder.php?folder=$goto_folder");
  exit();
}

if ($po_user['type'] < $user_type['administrator']) {
  /* Ensure mere users don't move/mangle a photo that isn't theirs! */
  $result = pg_query($database, "select identifier from photo where identifier='$photo_id' and users = $po_user[id]");
  if (pg_num_rows($result) <= 0) {
    site_epilog($database);
    header("location: login.php?reason=1");
    exit();
  }

  /* ...to an album that isn't theirs! */
  if ($destination_album != "") {
    $result = pg_query($database, "select identifier from album where identifier='$destination_album' and users = $po_user[id]");
    if (pg_num_rows($result) <= 0) {
      site_epilog($database);
      header("location: login.php?reason=2");
      exit();
    }
  }

  /* ...to a folder that isn't theirs! */
  if ($destination_folder != "") {
    $result = pg_query($database, "select identifier from folder where identifier='$destination_folder' and users = $po_user[id]");
    if (pg_num_rows($result) <= 0) {
      site_epilog($database);
      header("location: login.php?reason=3");
      exit();
    }
  }
}

if (($transform == "") &&
    ($destination_folder == "") &&
    ($destination_album == "") &&
    ($print_type == "") &&
    ($set_as_watermark == "") &&
    ($destination_basket == "")) {
  header("location: photo.php?photo=$photo_id&detail_info=$detail_info");
  exit();
}

if ($export_type != "") {
  pg_query($database, "delete from photo_spooler where users=$user_id");
  pg_query($database, "insert into photo_spooler (identifier, users, photo)
                       values (nextval('photo_spooler_id_sequence'), $user_id, $photo_id)");

  $arguments = "export_type=$export_type";
  if ($source_folder != "")
    $arguments = $arguments . "&source_folder=$source_folder";
  if ($source_album != "")
    $arguments = $arguments . "&source_album=$source_album";
  if ($source_photo != "")
    $arguments = $arguments . "&source_photo=$source_photo";
  header("location: export.php?$arguments");
  exit();
}

if ($print_type != "") {
  pg_query($database, "delete from photo_spooler where users=$po_user[id]");
  pg_query($database, "insert into photo_spooler (identifier, users, photo)
                       values (nextval('photo_spooler_id_sequence'), $po_user[id], $photo_id)");
  site_epilog($database);
  header("location: print.php?source_photo=$photo_id&print_type=$print_type");
  exit();
}

if ($destination_folder != "") {
  pg_query($database, "update photo set folder='$destination_folder' where identifier='$photo_id'");
}
elseif ($destination_album != "") {
  pg_query($database, "insert into album_content (identifier, photo, album)
                       values (nextval('album_content_id_sequence'), $photo_id, $destination_album)");
}
elseif ($destination_basket != "") {
  $all_photos_for_sale = pg_query($database, "
   select identifier,
          (select identifier
             from shop_order
            where shop_order.item=photo_item.identifier
              and shop_order.client=$po_user[id]
              and transaction is null) as already_selected
     from photo_item
    where photo=$photo_id");

  for ($counter = 0; $counter < pg_num_rows($all_photos_for_sale); $counter++) {
    $photo_for_sale = pg_fetch_row($all_photos_for_sale, $counter);
    if ($photo_for_sale[1]) {
      /* if already in the basket, update or remove */
      if ($_REQUEST[cb.$photo_for_sale[0]] != 'on') {
        pg_query($database, "
          delete from shop_order
           where item=$photo_for_sale[0]
             and client=$po_user[id]");
      }
    }
    else {
      /* if not in the basket insert if selected */
      if ($_REQUEST[cb.$photo_for_sale[0]] == 'on') {
        pg_query($database, "
          insert into shop_order (identifier, item, client, transaction, pieces, date_of_creation, date_of_last_edit, download_expiry_date)
          values (nextval('shop_order_id_sequence'), $photo_for_sale[0], $po_user[id], null, 1, now(), now(), now())");
      }
    }
  }
}
elseif ($set_as_watermark != "") {
  pg_query($database, "update imagemagick_composite_options
                          set photo_version = (select identifier from photo_version where photo=$photo_id)
                        where identifier = (select imagemagick_composite_options from users where identifier = $po_user[id])");
}
elseif ($transform != "") {

  $version_selector = $version ? "photo_version.identifier=$version" : "photo_version.master='t'";

  $photo_paths = pg_fetch_row(pg_query($database, "
    select small_image_path, medium_image_path, large_image_path, colorspace, orientation, photo_version.identifier, camera
      from photo, photo_version, photo_tech
     where photo.identifier = photo_version.photo
       and photo.identifier = photo_tech.photo
       and $version_selector
       and photo.identifier = '$photo_id'"));

  $camera_profile = pg_fetch_row(pg_query($database, "
    select raw_icc_profile 
      from photo_tech, camera, camera_type
     where photo_tech.photo = $photo_id
       and photo_tech.camera = camera.identifier
       and camera.type = camera_type.identifier"));

  $thumb = $image_repository_path ."/". $photo_paths[0];
  $preview = $image_repository_path ."/". $photo_paths[1];
  $original = $image_repository_path ."/". $photo_paths[2];
  $colorspace = $photo_paths[3];
  $orientation = $photo_paths[4];
  $version_id = $photo_paths[5];
  $camera_type = $photo_paths[6];

  $orientation = map_transform($orientation, $transform);

  pg_query($database, "update photo_version set orientation = $orientation where identifier = $version_id");

  $im_composite_options = get_im_composite_options($database, $po_user['id']);
  $im_options = get_im_options($database, $po_user['id']);
  $dcraw_options = get_dcraw_options($database, $po_user['id']);

  $orientation = orientation_to_xform($database, $orientation);

  $original_file_type   = strtolower(substr($original, strrpos($original, ".") + 1));
  $multi_page_parameter = $mime_type[$original_file_type]['page'];
  $decoder              = $mime_type[$original_file_type]['decoder'];

  $image_data = array();
  $temporary_ppm_file = import_raw_decode($original, $dcraw_options, $decoder, FALSE, $camera_profile[0], $image_data);
  if ($temporary_ppm_file) {
    $original = $temporary_ppm_file;
  }

  import_generate_preview($original, $preview, FALSE, $im_options, $im_composite_options, $multi_page_parameter, $orientation,	$colorspace);
  import_generate_thumbnail($original, $thumb, FALSE, $im_options, $multi_page_parameter, $orientation, $colorspace);
}


site_epilog($database);
header("location: photo.php?photo=$photo_id&detail_info=$detail_info&ver=$version");
?>
