<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/vars.php";
include_once "include/config.php";
include_once "include/tools.php";
include_once "include/mime.php";
include_once "$theme/theme.php";
include_once "include/common.php";
include_once "include/site.php";
include_once "include/import.php";

$select_folder   = pg_escape_string($_REQUEST['select_folder']);

if (!$select_folder) {
  /* return if no search criteria exists */
  header("location: my.tools.php?selector=2");
}

$database = site_prolog();

if ($po_user['type'] < $user_type['user']) {
  site_epilog($database);
  header("location: login.php");
  exit();
}

site_header($page_width, "Display Tools");
site_navigator(10);
site_navigator_status("<a href=\"user.php\">Users</a> : My Tools", "");

print "&nbsp;<br/>";
display_navigator_box_top($tools_data['shop_item_maker']['idx'], $tools_data, "100%");

if ($select_folder == "all") {
  $sql_selector = " users = $po_user[id] ";
} else {
  $sql_selector = " folder = $select_folder ";
}

$num_of_photos = pg_fetch_row(pg_query($database, "
  select count(identifier) from photo
   where $sql_selector"));

if ($_REQUEST['delete_all']) {
  $items_to_be_removed = pg_query($database, "
    select identifier, (photo_item.identifier in (select item from shop_order)) as refereced
      from photo_item
     where deleted = 'f'
       and photo in (select identifier from photo where $sql_selector)");

  for ($item = 0; $item < pg_num_rows($items_to_be_removed); $item++) {
    $to_be_removed = pg_fetch_row($items_to_be_removed, $item);
    if ($to_be_removed[1] == 't') {
      /* we do not remove those shop items that are referenced in a transaction */
      $result = pg_query($database, "update photo_item set deleted='t' where identifier=$to_be_removed[0]");
    } else {
      $result = pg_query($database, "delete from photo_item where identifier=$to_be_removed[0]");
    }
  }
} else {
  $all_rules = pg_query($database, "
  select identifier, shop_item, price, currency, comment from shop_item_generator_rule
   where users = $po_user[id]");

  for ($rule_counter = 0; $rule_counter < pg_num_rows($all_rules); $rule_counter++) {
    $rule_data = pg_fetch_row($all_rules, $rule_counter);
    $rule = $_REQUEST["rule".$rule_data[0]];

    if ($rule) {
      $shop_item = $rule_data[1];
      $price     = $rule_data[2];
      $currency  = $rule_data[3];
      $comment   = $rule_data[4];

      /* check all photos for the given criteria and check if the photo has already a deleted photo_item  */
      $all_selected_photos = pg_query($database, "
        select photo.identifier, (select photo_item.identifier from photo_item where photo_item.photo=photo.identifier and deleted='t' and shop_item=$shop_item) as already_defined
          from photo
         where $sql_selector");


      for ($photo_counter = 0; $photo_counter < pg_num_rows($all_selected_photos); $photo_counter++) {
        $selected_photo = pg_fetch_row($all_selected_photos, $photo_counter);
        /* if there is a deleted photo_item for the photo, for the given shop_item, undelete it */
        if ($selected_photo[1]) {
          $result = pg_query($database, "
            update photo_item
               set deleted='f',
                   price=$price,
                   currency=$currency,
                   comment = '$comment',
                   date_of_last_edit = now()
             where photo=$selected_photo[0]");
        }
        else {
          /* if there is no deleted photo_item for the given shop_item, create a new shop_item */
          $result = pg_query($database, "
            insert into photo_item (identifier, photo, shop_item, price, currency, comment, deleted, date_of_creation, date_of_last_edit)
            values (nextval('photo_item_id_sequence') as identifier,
                    $selected_photo[0] as photo,
                    $shop_item as shop_item,
                    $price as price,
                    $currency as currency,
                    '$comment' as comment,
                    'f' as deleted,
                    now() as date_of_creation,
                    now() as date_of_last_edit)");
        }
      }
    }
  }
}

print "<p align=\"left\">Updated ".$num_of_photos[0]." photos.</p>";

print "<p>";
print "<a class=\"nodecor\" href=\"my.tools.php?selector=2\"><img src=\"$theme/button.back.gif\" border=\"0\"/></a>";
print "</p>";


display_navigator_box_bottom("100%");
print "&nbsp;<br/>";

site_footer($database);
site_epilog($database);



?>
