
--  Copyright (C) 2002, 2003, 2004, 2005, 2006 Balint Kis (balint@k-i-s.net)

--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 2 of the License, or
--  (at your option) any later version.

--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.

--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

----------------------------------------------------------
-- v2.26 to v2.27 patch
----------------------------------------------------------

-- version upldate
update version set identifier=3, description='2.27 customer release', major=2, minor=27, variation='B';

-- BEGIN: Inserting value 64 into film_iso
drop view view_film_type;
drop view view_film;

insert into film_iso values (nextval('film_iso_id_sequence'), '64');
alter table film_iso add column value_2 integer;
update film_iso set value_2 = to_number(value, '9999');
alter table film_iso drop column value;
alter table film_iso rename column value_2 to value;

create view view_film_type as
  select film_type.identifier, manufacturer.name, model, film_iso.value as iso, film_format.value as format, manufacturer.url
    from film_type, manufacturer, film_iso, film_format
   where film_type.manufacturer = manufacturer.identifier
     and film_type.iso = film_iso.identifier
     and film_type.format = film_format.identifier
   order by manufacturer.name, model, film_iso.value;

create view view_film as
  select film.identifier, manufacturer.name, model, film_iso.value as iso, film_format.value as format, film.users, manufacturer.url, (access_type.value) as access_rights
    from film_type, film, manufacturer, film_iso, film_format, access_type
   where film_type.manufacturer = manufacturer.identifier
     and film_type.identifier = film.type
     and film_type.iso = film_iso.identifier
     and film_type.format = film_format.identifier
     and film.access_rights = access_type.identifier
   order by manufacturer.name, model, film_iso.value;
-- END: Inserting value 64 into film_iso
