
--  Copyright (C) 2002, 2003, 2004, 2005, 2006 Balint Kis (balint@k-i-s.net)

--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 2 of the License, or
--  (at your option) any later version.

--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.

--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

----------------------------------------------------------
-- v2.22 to v2.23 patch
----------------------------------------------------------

create sequence bulk_update_rule_id_sequence start 1;
create table bulk_update_rule (
  identifier             integer not null primary key,
  users                  integer not null references users(identifier),
  rule_name              varchar(300),
  regenerate_thumbnail   char(1) check (regenerate_thumbnail in ('t', 'f')),
  regenerate_preview     char(1) check (regenerate_preview in ('t', 'f')),
  title                  text,
  author                 text,
  keyword                text,
  headline               text,
  caption_writer         text,
  caption                text,     
  category               varchar(3),
  supplemental_category  text,
  credit                 text,
  copyright_statement    text,
  web_statement          text,
  instructions           text,
  source                 text,
  transmission_reference text,
  date_of_exposure       timestamp,
  access_rights          integer not null references access_type(identifier),
  hide_original          char(1) check (hide_original in ('t', 'f')),
  location               integer references location(identifier),
  camera                 integer references camera(identifier),
  camera_metering        integer references camera_metering(identifier),
  camera_program         integer references camera_program(identifier),
  lens                   integer references lens(identifier),
  focal_length           integer references focal_length(identifier),   
  filter                 integer references filter(identifier),
  film                   integer references film(identifier),
  iso_override           integer references film_iso(identifier),
  aperture               integer references aperture(identifier),       
  shutter                integer references shutter(identifier),
  exposure_comp          integer references ev_comp(identifier),
  ev_difference          integer references ev_comp(identifier),
  flash                  integer references flash(identifier),
  flash_mode             integer references flash_mode(identifier),
  flash_comp             integer references ev_comp(identifier),
  scanner                integer references scanner(identifier),
  scan_resolution        integer references scan_resolution(identifier),
  scan_bitdepth          integer references scan_bitdepth(identifier),
  scan_multiscan         integer references scan_multiscan(identifier),
  support                integer references support(identifier)
);
