<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/vars.php";
include_once "include/config.php";
include_once "include/tools.php";
include_once "$theme/theme.php";
include_once "include/common.php";
include_once "include/export.php";
include_once "include/site.php";

$database = site_prolog();

if ($po_user['type'] < $user_type['user']) {
  site_epilog($database);
  header("location: login.php");
  exit();
}

$source_file      = $_FILES['source_file']['name'][0];
$source_file_type = $_FILES['source_file']['type'][0];
$source_file_tmp  = $_FILES['source_file']['tmp_name'][0];
$source_file_extension = strtolower(strrchr ($source_file, "."));

$temp_file = tempnam("/tmp", "po");
error_reporting(0);
if (!copy($source_file_tmp, $temp_file)) {
  site_epilog($database);
  header("location: my.tools.php?selector=2");
  exit();
}
error_reporting(1);
$fd = fopen($source_file_tmp, "r");
$header_data = convert_read_header($fd, $source_file_extension);
$shooting_data = convert_read_body($fd, $source_file_extension);
fclose($fd);

if ($po_user['type'] != $user_type['administrator'])
  $location_mod = " where private is false or users=$po_user[id] ";
 else
   $location_mod = "";

$users_location  = pg_query($database, "select identifier, country, state, city, place from view_location $location_mod order by country, state, city, place");

$users_folder    = pg_query($database, "select identifier, caption from folder where users=$po_user[id] and caption!='Trash' and caption!='Orphanage'");
$users_camera    = pg_query($database, "select identifier, name, model, variation from view_camera where users=$po_user[id]");
$users_flash     = pg_query($database, "select identifier, name, model, variation from view_flash where users=$po_user[id]");
$users_scanner   = pg_query($database, "select identifier, name, model, variation from view_scanner where users=$po_user[id]");
$users_filter    = pg_query($database, "select identifier, name, model, variation from view_filter where users=$po_user[id]");
$users_support   = pg_query($database, "select identifier, name, model, variation from view_support where users=$po_user[id]");

$scan_resolution = pg_query($database, "select identifier, value from scan_resolution");
$scan_bitdepth   = pg_query($database, "select identifier, value from scan_bitdepth");
$scan_multiscan  = pg_query($database, "select identifier, value from scan_multiscan");
$iso_override    = pg_query($database, "select identifier, value from film_iso");

site_header($page_width, "Tools : XML Converter");
site_navigator(10);
site_navigator_status("<a href=\"user.php\">Users</a> : <a href=\"my.tools.php\">My Tools</a> : XML Converter", "");

if ($header_data[iso]) {
  $users_film = pg_query($database, "select identifier, name, model, iso       from view_film where users=$po_user[id] and iso=$header_data[iso]");
}

print "&nbsp;<br/>";
display_navigator_box_top($tools_data['converter']['idx'], $tools_data, "100%");

print "&nbsp;<br/>";

print "<form method=\"post\" action=\"xml.converter.2.php\">\n";
print "<input type=\"hidden\" name=\"source_file_tmp\" value=\"$temp_file\"/>\n";
print "<input type=\"hidden\" name=\"source_file_extension\" value=\"$source_file_extension\"/>\n";
print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
print "<tr>\n";
print "<td align=\"left\"   bgcolor=\"$color[table_top]\"  colspan=2>Fill in the image details and default values</td>\n";
print "</tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Image file name</td>\n       <td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"75%\">";
print "<input type=\"text\" name=\"file_name\" value=\"$file_name\" title=\"Root of the file name - the part which is constant\"/>";

print "<select name=\"file_number_digits\" title=\"Number of digits in the file name including 0. For 00234 this number is 5\">";
for ($i=1; $i < 11; $i++) {
  print "<option value=$i>$i";
}
print "</select>";
print " . <input type=\"text\" name=\"file_format\" value=\"$file_format\" size=\"5\" title=\"File format, ex: jpg, gif, ...\"/>";

print"</td>\n</tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Start number</td>\n<td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"75%\">";
print "<input type=\"text\" name=\"file_number_start\" value=\"$file_number_start\" size=\"10\" title=\"File start number - the number of the first photo\"/>";
print "</td>\n</tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Number of frames</td>\n<td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"75%\">";
print "<input type=\"text\" name=\"frame_number\" value=\"$frame_number\" size=\"10\" title=\"For how many photos you want to generate the XML file\"/>";
print "</td>\n</tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Folder</td>            <td align=\"left\" bgcolor=\"$color[table_body]\" >";
display_folder_combo("folder", $users_folder, $current_folder, "");
print "</td></tr>\n";

print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Title</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
print "<input type=\"text\" name=\"title\" size=\"60\" title=\"The title of the Photo\"/></td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Author</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
print "<input type=\"text\" name=\"author\" size=\"60\" title=\"Photographer's Name\"/></td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Keywords</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
print "<textarea wrap=\"hard\"  name=\"keywords\" rows=\"3\" cols=\"60\"></textarea></td></tr>\n";

print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Location</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
display_combo("location", $users_location, 0, ", ", 0);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Storage Location</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
display_storage_location_combo("storage_location_type", "");
print "<input type=\"text\" name=\"storage_location_id\" size=\"10\" title=\"Storage location identifier - this will be incremented when the index wraps around\"/> -
       <input type=\"text\" name=\"storage_index\" size=\"4\" title=\"Storage location index - this must be a number and will be incremented for each photo\"/> :
       <input type=\"text\" name=\"storage_size\" size=\"4\" title=\"Storage location size - the storage index will wrap around when reaches this limit\"/>";
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Access</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
display_access_combo("access_rights", "t", "");
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">High Resolution Original</td><td align=\"left\" valign=\"middle\" bgcolor=\"$color[table_body]\" >";
display_hide_original_combo("hide_original", "t");
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Camera</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
display_combo("camera", $users_camera, 0, "", 0);
print "</td></tr>\n";
if ($users_film) {
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Film</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  display_combo("film", $users_film, 0, "", 0);
  print "</td></tr>\n";
}
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Film ISO Override</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
display_combo("iso_override", $iso_override, 0, "", 0);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Scanner</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
display_combo("scanner", $users_scanner, 0, "", 0);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Scan Parameters</td><td align=\"left\" valign=\"middle\" bgcolor=\"$color[table_body]\" >\n";
display_combo("scan_resolution", $scan_resolution, 0, "", 0);
print "dpi &nbsp;\n";
display_combo("scan_bitdepth", $scan_bitdepth, 0, "", 0);
print "bits &nbsp;\n";
display_combo("scan_multiscan", $scan_multiscan, 0, "", 0);
print "passes &nbsp;\n";
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Support</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
display_combo("support", $users_support, 0, "", 0);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"30%\" nowrap>Copyright Statement</td> <td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"70%\">";
print "<textarea wrap=\"hard\"  name=\"copyright\" rows=\"7\" cols=\"60\">$my_preferences[0]</textarea>\n";
print "</table>\n";


$data = $shooting_data[data];


print "&nbsp;<br/>\n";
print "<div >For some frames multiple lenses match the focal length. Please specify the lens below:</div>\n";
print "&nbsp;<br/>\n";
print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
print "<tr><td align=\"center\" bgcolor=\"$color[table_header]\"  width=\"10%\">Frame Number</td>\n";
print "<td align=\"center\" bgcolor=\"$color[table_header]\"  width=\"10%\">Focal Length</td>\n";
print "<td align=\"left\" bgcolor=\"$color[table_header]\" >Select a Lens</td>\n";
print "<td align=\"left\" bgcolor=\"$color[table_header]\" >Select a Flash</td></tr>\n";
for ($i=1; $i < $shooting_data[frames]; $i++) {
  $frame_data = $data[$i];
  print "<tr>";
  print "<td align=\"center\" bgcolor=\"$color[table_body]\"  width=\"10%\">$i</td>";
  print "<td align=\"center\" bgcolor=\"$color[table_body]\"  width=\"10%\">$frame_data[focal_length]</td>";
  print "<td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  if ($frame_data[focal_length] != "") {
    /* all lenses having that focal length */
    $users_lens = pg_query($database, "select identifier, name, model, variation, s_min_aperture, s_max_aperture, s_min_focal_length, s_max_focal_length
                                         from view_lens
                                        where users = $po_user[id]
                                          and $frame_data[focal_length] >= to_number(s_min_focal_length, 9999)
                                          and $frame_data[focal_length] <= to_number(s_max_focal_length, 9999)");

    /* best match */
    $current_lens = pg_fetch_row(pg_query($database, "select identifier from view_lens
                                                       where users = $po_user[id]
                                                         and $frame_data[focal_length] = to_number(s_min_focal_length, 9999)
                                                         and $frame_data[focal_length] = to_number(s_max_focal_length, 9999)"));

  } else {
    /* all lenses disregarding focal length */
    $users_lens = pg_query($database, "select identifier, name, model, variation, s_min_aperture, s_max_aperture, s_min_focal_length, s_max_focal_length
                                         from view_lens
                                        where users=$po_user[id]");
  }

  if (pg_num_rows($users_lens) == 1) {
    $current_value = pg_fetch_row($users_lens, 0);
    display_lens_combo("lens$i", $users_lens, $current_value[0], 0, 0);
  } else {
    display_lens_combo("lens$i", $users_lens, $current_lens[0], 0, 0);
  }

  print "</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
  if ($frame_data[flash_mode] != "") {
    display_combo("flash$i", $users_flash, 0, "", 0);
  }
  print "</td>";
  print "</tr>\n";
}
print "</table>\n";

print "&nbsp;<br/>";
print "<input type=\"image\" src=\"$theme/button.submit.gif\" border=\"0\" value=\"Submit\"/>";
print "</form>\n";

display_navigator_box_bottom("100%");
print "&nbsp;<br/>";

site_footer($database);
site_epilog($database);
?>
